LeetCode 532 - K-diff Pairs in an Array


https://leetcode.com/problems/k-diff-pairs-in-an-array/
Given an array of integers and an integer k, you need to find the number of unique k-diff pairs in the array. Here a k-diff pair is defined as an integer pair (i, j), where i and j are both numbers in the array and their absolute difference is k.
Example 1:
Input: [3, 1, 4, 1, 5], k = 2
Output: 2
Explanation: There are two 2-diff pairs in the array, (1, 3) and (3, 5).
Although we have two 1s in the input, we should only return the number of unique pairs.
Example 2:
Input:[1, 2, 3, 4, 5], k = 1
Output: 4
Explanation: There are four 1-diff pairs in the array, (1, 2), (2, 3), (3, 4) and (4, 5).
Example 3:
Input: [1, 3, 1, 5, 4], k = 0
Output: 1
Explanation: There is one 0-diff pair in the array, (1, 1).
Note:
  1. The pairs (i, j) and (j, i) count as the same pair.
  2. The length of the array won't exceed 10,000.
  3. All the integers in the given input belong to the range: [-1e7, 1e7].
X.
https://wlypku.github.io/2017/03/05/Leetcode-week22/
* for every number in the array:
* - if there was a number previously k-diff with it, save the smaller to a set;
* - and save the value to a set;
*/
int findPairs(vector<int>& nums, int k) {
if (k < 0) {
return 0;
}
set<int> starters;
set<int> indices;
for (int i = 0; i < nums.size(); i++) {
if (indices.find(nums[i] - k) != indices.end()) {
starters.insert(nums[i] - k);
}
if (indices.find(nums[i] + k) != indices.end()) {
starters.insert(nums[i]);
}
indices.insert(nums[i]);
}
return starters.size();
}
X.
https://discuss.leetcode.com/topic/81714/java-o-n-solution-one-hashmap-easy-to-understand
将数组值用hashmap来存起来,value来存储个数。如果k=0的话,value>=2的时候count+1,如果k不等于0,则看key+k的值在map里面是否包含,包含的话就count+1
    public int findPairs(int[] nums, int k) {
        if (nums == null || nums.length == 0 || k < 0)   return 0;
        
        Map<Integer, Integer> map = new HashMap<>();
        int count = 0;
        for (int i : nums) {
            map.put(i, map.getOrDefault(i, 0) + 1);
        }
        
        for (Map.Entry<Integer, Integer> entry : map.entrySet()) {
            if (k == 0) {
                //count how many elements in the array that appear more than twice.
                if (entry.getValue() >= 2) {
                    count++;
                } 
            } else {
                if (map.containsKey(entry.getKey() + k)) {
                    count++;
                }
            }
        }
        
        return count;
    }
https://discuss.leetcode.com/topic/81714/java-o-n-solution-one-hashmap-easy-to-understand/7
    public int findPairs(int[] nums, int k) {
        Map<Integer,Integer> mp = new HashMap<Integer,Integer>();
        if(k<0)
            return 0;
            
        for(int i=0;i<nums.length;i++) {
            mp.put(nums[i],i);
        }
        
        int cnt=0;
        for(int i=0;i<nums.length;i++) {
            if(mp.containsKey(k+nums[i]) && mp.get(k+nums[i])!=i) {
                cnt++;
                mp.remove(k+nums[i]);
            }
        }
        return cnt;
    }
X. Pre-Sort + Two Pointers
https://leetcode.com/problems/k-diff-pairs-in-an-array/discuss/100104/Two-pointer-Approach
The problem is just a variant of 2-sum.
Update: Fixed a bug that can cause integer subtraction overflow.
Update: The code runs in O(n log n) time, using O(1) space.
public int findPairs(int[] nums, int k) {
    int ans = 0;
    Arrays.sort(nums);
    for (int i = 0, j = 0; i < nums.length; i++) {
        for (j = Math.max(j, i + 1); j < nums.length && (long) nums[j] - nums[i] < k; j++) ;
        if (j < nums.length && (long) nums[j] - nums[i] == k) ans++;
        while (i + 1 < nums.length && nums[i] == nums[i + 1]) i++;
    }
    return ans;
}
https://discuss.leetcode.com/topic/81745/two-pointer-approach
   public int findPairs(int[] nums, int k) {
        Arrays.sort(nums);

        int start = 0, end = 1, result = 0;
        while (start < nums.length && end < nums.length) {
            if (start == end || nums[start] + k > nums[end]) {
                end++;
            } else if (nums[start] + k < nums[end]) {
                start++;
            } else {
                start++;
                result++;
                // start
                //  |
                // [1, 1, ...., 8, 8]
                //              |
                //             end
                while (start < nums.length && nums[start] == nums[start - 1]) start++;
                end = Math.max(end + 1, start + 1);
            }
        }
        return result;
    }
The problem is just a variant of 2-sum.
Update: Fixed a bug that can cause integer subtraction overflow.
Update: The code runs in O(n log n) time, using O(1) space.
public int findPairs(int[] nums, int k) {
    int ans = 0;
    Arrays.sort(nums);
    for (int i = 0, j = 0; i < nums.length; i++) {
        for (j = Math.max(j, i + 1); j < nums.length && (long) nums[j] - nums[i] < k; j++) ;
        if (j < nums.length && (long) nums[j] - nums[i] == k) ans++;
        while (i + 1 < nums.length && nums[i] == nums[i + 1]) i++;
    }
    return ans;
}
https://discuss.leetcode.com/topic/81678/self-explained-ac-java-sliding-window
 public  int findPairs(int[] nums, int k) {
 if(k<0 || nums.length<=1){
     return 0;
 }
   
         Arrays.sort(nums);
         int count = 0;
         int left = 0;
         int right = 1;
         
         while(right<nums.length){
             int firNum = nums[left];
             int secNum = nums[right];
             // If less than k, increase the right index
             if(secNum-firNum<k){
                 right++;
             }
             // If larger than k, increase the left index
             else if(secNum - firNum>k){
                 left++;   
             }
             // If equal, move left and right to next different number
             else{
                 count++;
                 while(left<nums.length && nums[left]==firNum){
                     left++;
                 }
                 while(right<nums.length && nums[right]==secNum){
                     right++;
                 }
                             
             }
             //left and right should not be the same number
             if(right==left){
              right++;
             }
         }
        return count;
    }
https://discuss.leetcode.com/topic/81897/simple-idea-o-nlogn-time-o-1-space-java-solution
    public int findPairs(int[] nums, int k) {
        if (nums == null || nums.length < 2) return 0;
        int res = 0;
        Arrays.sort(nums);
        for (int i = 0; i < nums.length; i++) {
            if (i > 0 && nums[i] == nums[i - 1]) continue;
            if (helper(nums, i + 1, nums[i] + k)) res++;
        }
        return res;
    }
    private boolean helper(int[] nums, int l, int target) {
        int r = nums.length - 1;
        while (l <= r) {
            int mid = l + (r - l) / 2;
            if (nums[mid] == target) return true;
            if (nums[mid] < target) l = mid + 1;
            else r = mid - 1;
        }
        return false;
    }
X. Using hashset
https://discuss.leetcode.com/topic/81690/short-java-solution-but-two-hashsets
    public int findPairs(int[] nums, int k) {
        Arrays.sort(nums);
        Set<Integer> seenNum = new HashSet<>();
        Set<String> seenPair = new HashSet<>();
        int result = 0;
        
        for (int i = 0; i < nums.length; i++) {
            int prev = nums[i] - k;
            if (seenNum.contains(prev) && !seenPair.contains(prev + "," + nums[i])) {
                result++;
                seenPair.add(prev + "," + nums[i]);
            }
            seenNum.add(nums[i]);
        }
        return result;
    }
http://blog.csdn.net/zhouziyu2011/article/details/60466898
成对的值不分先后,所以先对nums进行排序。
用一个set存储出现过的值,用于后续判断是否某个值已经有值与其成对。
分为两种情况:
(1)k==0,即找出值相等的对数。
再用一个sameSet存储所有已成对的值,避免同一个值加入结果多次。只有sameSet中不含该值,且set中包含了该值,才能加入结果。
(2)k!=0,即找出差的绝对值为k的对数。
只有set中不包含该值但包含了该值-k,才能加入结果。

  1.     public int findPairs(int[] nums, int k) {  
  2.         int len = nums.length, result = 0;  
  3.         Arrays.sort(nums);  
  4.         Set<Integer> set = new HashSet<Integer>();  
  5.         Set<Integer> sameSet = new HashSet<Integer>();  
  6.         if (k != 0) {  
  7.             for (int i = 0; i < len; i++) {  
  8.                 if (!set.contains(nums[i]) && set.contains(nums[i] - k))   
  9.                     result++;  
  10.                 set.add(nums[i]);  
  11.             }  
  12.         }  
  13.         else {  
  14.             for (int i = 0; i < len; i++) {  
  15.                 if (!sameSet.contains(nums[i]) && set.contains(nums[i])) {  
  16.                     result++;  
  17.                     sameSet.add(nums[i]);  
  18.                 }  
  19.                 set.add(nums[i]);  
  20.             }   
  21.         }  
  22.         return result;  
  23.     } 
http://www.techiedelight.com/find-pairs-with-given-difference-array/
Given an unsorted array of integers, print all pairs with given difference k in it.
arr = [1, 5, 2, 2, 2, 5, 5, 4]
k = 3

Output:
(2, 5) and (1, 4)

void findPair(int arr[], int n, int diff)

{
    // array is unsorted
    // take an empty set
    unordered_set<int> set;
    // do for each element in the array
    for (int i = 0; i < n; i++)
    {
        // check if pair with given difference (arr[i], arr[i]-diff) exists
        if (set.find(arr[i] - diff) != set.end())
            cout << "(" << arr[i] << ", " << arr[i] - diff<< ")\n";
        // check if pair with given difference (arr[i]+diff, arr[i]) exists
        if (set.find(arr[i] + diff) != set.end())
            cout << "(" << arr[i] + diff << ", " << arr[i] << ")\n";
        // insert element into the set
        set.insert(arr[i]);
    }
}

We can handle duplicates pairs by sorting the array first and then skipping adjacent similar elements.
void findPair(int arr[], int n, int diff)
{
    // sort array in ascending order
    sort(arr, arr + n);
    // take an empty set
    unordered_set<int> set;
    // do for each element in the array
    for (int i = 0; i < n; i++)
    {
        // to avoid printing duplicates (skip adjacent duplicates)
        while (i < n && arr[i] == arr[i+1])
            i++;
        // check if pair with given difference (arr[i], arr[i]-diff) exists
        if (set.find(arr[i] - diff) != set.end())
            cout << "(" << arr[i] << ", " << arr[i] - diff << ")\n";
        // check if pair with given difference (arr[i]+diff, arr[i]) exists
        if (set.find(arr[i] + diff) != set.end())
            cout << "(" << arr[i] + diff << ", " << arr[i] << ")\n";
        // insert element into the set
        set.insert(arr[i]);
    }
}

We can avoid using extra space by performing binary search for element (arr[i] – diff) or (arr[i] + diff) instead of using hashing.
void findPair(int arr[], int n, int diff)
{
    // sort array in ascending order
    sort(arr, arr + n);
    // do for each element in the array
    for (int i = 0; i < n; i++)
    {
        // to avoid printing duplicates (skip adjacent duplicates)
        while (i < n && arr[i] == arr[i+1])
            i++;
        // perform binary search for element (arr[i] - diff)
        if (binary_search(arr, arr + n, arr[i] - diff))    // STL binary search
            cout << "(" << arr[i] << ", " << arr[i] - diff << ")\n";
    }
}

void findPair(int arr[], int n, int diff)
{
    // sort array in ascending order
    sort(arr, arr + n);
    // maintain two indexes in the array
    int i = 0, j = 0;
    // run till end of array is reached
    while (i < n && j < n)
    {
        // to avoid printing duplicates
        while (i < n && arr[i] == arr[i+1])
            i++;
        while (j < n && arr[j] == arr[j+1])
            j++;
        // increment i if current difference is more than the desired difference
        if (arr[j] - arr[i] > diff)
            i++;
        // increment j if current difference is less than the desired difference
        else if (arr[j] - arr[i] < diff)
            j++;
        // print the pair and increment both i, j if current difference is same
        // as the desired difference
        else
        {
            cout << "(" << arr[j] << ", " << arr[i] << ")\n";
            i++, j++;
        }
    }
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts